export declare abstract class Node {
    get root(): Uint8Array;
    isLeaf(): boolean;
    get left(): Node;
    get right(): Node;
    rebindLeft(left: Node): Node;
    rebindRight(right: Node): Node;
}
export declare class BranchNode extends Node {
    private _left;
    private _right;
    private _root;
    constructor(_left: Node, _right: Node);
    get root(): Uint8Array;
    isLeaf(): boolean;
    get left(): Node;
    set left(n: Node);
    get right(): Node;
    set right(n: Node);
    rebindLeft(left: Node): Node;
    rebindRight(right: Node): Node;
}
export declare class LeafNode extends Node {
    private _root;
    constructor(_root: Uint8Array);
    get root(): Uint8Array;
    isLeaf(): boolean;
}
export declare type Link = (n: Node) => Node;
export declare function identity(n: Node): Node;
export declare function compose(inner: Link, outer: Link): Link;
