import { Gindex } from "./gindex";
import { Node, Link } from "./node";
import { Proof, ProofInput } from "./proof";
export declare type Hook = (v: Tree) => void;
export declare class Tree {
    private _node;
    private hook?;
    constructor(node: Node, hook?: Hook);
    static createFromProof(proof: Proof): Tree;
    get rootNode(): Node;
    set rootNode(n: Node);
    get root(): Uint8Array;
    getNode(index: Gindex): Node;
    setter(index: Gindex, expand?: boolean): Link;
    setNode(index: Gindex, n: Node, expand?: boolean): void;
    getRoot(index: Gindex): Uint8Array;
    setRoot(index: Gindex, root: Uint8Array, expand?: boolean): void;
    getSubtree(index: Gindex): Tree;
    setSubtree(index: Gindex, v: Tree, expand?: boolean): void;
    clone(): Tree;
    getSingleProof(index: Gindex): Uint8Array[];
    /**
     * Fast read-only iteration
     * In-order traversal of nodes at `depth`
     * starting from the `startIndex`-indexed node
     * iterating through `count` nodes
     */
    iterateNodesAtDepth(depth: number, startIndex: number, count: number): IterableIterator<Node>;
    getProof(input: ProofInput): Proof;
}
